/*
 *  Copyright (C) 2007  Thadeu Lima de Souza Cascardo <cascardo@holoscopio.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */


#ifndef ATOMPUB_BACKEND_H
#define ATOMPUB_BACKEND_H

#include <atompub/ctx.h>
#include <atompub/entry.h>
#include <atompub/iri.h>
#include <atompub/feed.h>

typedef struct _atom_backend AtomBackend;

AtomBackend *atom_backend_new (void);
void atom_backend_delete (AtomBackend *);
void atom_backend_retrieve_entry_set (AtomBackend *,
				      AtomEntry * (AtomCtx *, char *));
void atom_backend_enumerate_entries_set (AtomBackend *,
					 void (AtomCtx *, char ***,
					       AtomEntry ***, size_t *));
void atom_backend_publish_entry_set (AtomBackend *,
				     void (AtomCtx *, char *, AtomEntry*));
AtomEntry * atom_retrieve_entry (AtomCtx *, char *);
void atom_enumerate_entries (AtomCtx *, char ***, AtomEntry ***, size_t *);
AtomFeed * atom_retrieve_feed (AtomCtx *);
void atom_publish_entry (AtomCtx *, char *, AtomEntry *);
AtomBackend * atom_backend (AtomCtx *);
void atom_backend_set (AtomCtx *, AtomBackend *);

#endif
